From 28241a0d362ad9ab326f52e760428ae39f4e453b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:18:17 +0000
Subject: [PATCH 801/2232] Move cargo based logic out of paths module


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 22f53f6..2f94426 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -59,7 +59,7 @@ mod gen;
 mod paths;
 mod syntax;
 
-use crate::error::Result;
+use crate::error::{Error, Result};
 use crate::gen::error::report;
 use crate::gen::{fs, Opt};
 use crate::paths::TargetDir;
@@ -99,7 +99,7 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
 }
 
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
-    let ref target_dir = paths::target_dir()?;
+    let ref target_dir = target_dir()?;
     let mut build = paths::cc_build(target_dir);
     build.cpp(true);
     build.cpp_link_stdlib(None); // linked via link-cplusplus crate
@@ -151,3 +151,16 @@ fn write(path: &Path, content: &[u8]) -> Result<()> {
     fs::write(path, content)?;
     Ok(())
 }
+
+fn target_dir() -> Result<TargetDir> {
+    let fallback_err = match cargo::target_dir() {
+        Ok(target_dir) => return Ok(target_dir),
+        Err(err) => Error::TargetDir(err),
+    };
+
+    // Fallback if Cargo did not work.
+    match paths::search_parents_for_target_dir() {
+        Some(target_dir) => Ok(target_dir),
+        None => Err(fallback_err),
+    }
+}
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 870c49d..47a28a0 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -1,4 +1,3 @@
-use crate::cargo;
 use crate::error::{Error, Result};
 use crate::gen::fs;
 use std::env;
@@ -80,20 +79,14 @@ pub(crate) fn include_dir(target_dir: &TargetDir) -> PathBuf {
     target_dir.join("cxxbridge")
 }
 
-pub(crate) fn target_dir() -> Result<TargetDir> {
-    let fallback_err = match cargo::target_dir() {
-        Ok(target_dir) => return Ok(target_dir),
-        Err(err) => Error::TargetDir(err),
-    };
-
-    // Fallback if Cargo did not work.
-    let mut dir = out_dir().and_then(canonicalize)?;
+pub(crate) fn search_parents_for_target_dir() -> Option<TargetDir> {
+    let mut dir = out_dir().and_then(canonicalize).ok()?;
     loop {
         if dir.ends_with("target") {
-            return Ok(TargetDir(dir));
+            return Some(TargetDir(dir));
         }
         if !dir.pop() {
-            return Err(fallback_err);
+            return None;
         }
     }
 }

